'use strict';

const lowering = require('./shared/oniguruma-to-js.99989dc1.cjs');

function loweringTextmateGrammar(grammar, options = {}) {
  const clone = structuredClone(grammar);
  const {
    handlePattern = (pattern) => lowering.syntaxLowering(pattern, { preserveFlags: true }).pattern
  } = options;
  function handle(regex) {
    return handlePattern(regex, clone);
  }
  function traverse(a) {
    if (!a)
      return;
    if (a.match)
      a.match = handle(a.match);
    if (a.begin)
      a.begin = handle(a.begin);
    if (a.end)
      a.end = handle(a.end);
    if (a.patterns) {
      a.patterns.forEach((j) => {
        traverse(j);
      });
    }
    Object.values(a.repository || {}).forEach((j) => {
      traverse(j);
    });
  }
  traverse(clone);
  return clone;
}

exports.loweringTextmateGrammar = loweringTextmateGrammar;
